
function getLatex(elem)
{
	return $('#'+elem).mathquill('latex');
}

//   {, \(  (  }, \)  )
function DoBrackets(str)
{
	var s = str;
	s =  s.replace(/\{/g, "(");
	s =  s.replace(/\\left\(/g, "(");
	s =  s.replace(/\}/g, ")");
	s =  s.replace(/\\right\)/g, ")");
	s =  s.replace(/\\left\[/g, "(");
	s =  s.replace(/\\right\]/g, ")");
	return s;
}


//    false     

//   
function RemSpaces(str)
{
	return str.replace(/\\:/g, "");
}

//    
//  
function RemLeftSlashes(str)
{
	return str.replace(/\\/g, "");
}

//  \cdor  *
function DoDots(str)
{
	return str.replace(/\\cdot/g, "*");
}

//      
// pos   '('
// : x+(sin(x))-3		 pos = 2  9
// opensymb -   
// closesymb -   
function getRightBr(str, pos, opensymb, closesymb)
{
	opensymb = opensymb || '(';
	closesymb = closesymb || ')';
	var len = str.length;
	if (pos >= len || pos < 0) throw "! Error";
	if (str.charAt(pos) != opensymb) throw "!   ";
	var p = pos;
	var leftbr=1, rightbr=0;
	while (p < len && rightbr<leftbr) {
		p++;
		var c = str.charAt(p);
		if (c==opensymb) leftbr++;
		if (c==closesymb) rightbr++;
	}
	if (rightbr<leftbr && p==len) throw "!     ";
	//  p    
	return p;
}

//     
//       getRightBr
// pos    
function getLeftBr(str, pos, opensymb, closesymb)
{
	opensymb = opensymb || '(';
	closesymb = closesymb || ')';
	var len = str.length;
	if (pos >= len || pos < 0) throw "! Error";
	if (str[pos] != closesymb) throw "!   ";
	var p = pos;
	var leftbr=0, rightbr=1;
	while (p > 0 && rightbr>leftbr) {
		p--;
		var c = str[p];
		if (c==opensymb) leftbr++;
		if (c==closesymb) rightbr++;
	}
	if (rightbr>leftbr && p==0) throw "!     ";
	//  p    
	return p;
}

//  \frac()()  ()/()
function DoFracs(str)
{
	var fr = -1;
	var rstr = str;
	do {
		fr = rstr.search(/\\frac/);
		if (fr == -1) break;
		var st = fr+5;
		var rb = getRightBr(rstr, st);
		var numer = rstr.substring(st, rb+1);
		st = rb+1;
		rb = getRightBr(rstr, st);
		var denom = rstr.substring(st, rb+1);
		var frexpr = rstr.substring(fr,rb+1);
		var newfr = numer+"/"+denom;
		rstr = rstr.replace(frexpr, newfr);
	} while (fr!=-1);
	return rstr;
}

//  
//      mathfuncs.php
var funcarr = ['arcsin', 'arccos', 'arctg', 'arcctg', 'sin', 'cos', 'tg', 'ctg', 'sh', 'ch', 'th', 'cth', 'ln', 'lg', 'log', 'sqrt', 'sqrtn', 'abs', 'factorial'];

// sin^2() -> sin()^2  ..     
function DoFunPows(str)
{
	var tstr = str;
	for (i=0; i<funcarr.length; i++)
	{
		var func = funcarr[i];
		var fp = tstr.search(new RegExp(func+"\\^"));
		while (fp != -1) {
			var pp = fp+func.length;
			var pfp = pp+1;	// power first position
			var plp = pfp;	// power last position
			if (tstr[pfp] == '(') {
				plp = getRightBr(tstr, pfp);
			} else {
				plp = pfp;
			}
			var ffb = plp+1;	// func first bracket
			if (tstr[ffb] != '(') throw "!     " + func;
			var flb = getRightBr(tstr, ffb);	// func last bracket
			tstr = tstr.substring(0,fp) + "(" + tstr.substring(fp,pp) + tstr.substring(ffb, flb+1) + tstr.substring(pp, plp+1) + ")" + tstr.substring(flb+1);
			
			fp = tstr.search(new RegExp(func+"\\^"));
		}
	}
	return tstr;
}

// log_(a)(b) -> logn(b,a)
function DoLog(str)
{
	var tstr = str;
	var fp = tstr.search(new RegExp("log\\_"));
	while (fp != -1) {
		var pp = fp+3;
		var pfp = pp+1;	// base first position
		var plp = pfp;	// base last position
		if (tstr[pfp] == '(') {
			plp = getRightBr(tstr, pfp);
		} else {
			plp = pfp;
		}
		var ffb = plp+1;	// func first bracket
		if (tstr[ffb] != '(') throw "!     log";
		var flb = getRightBr(tstr, ffb);	// func last bracket
		tstr = tstr.substring(0,pp) + '(' + tstr.substring(ffb, flb+1) + ',' + tstr.substring(pfp, plp+1) + ')' + tstr.substring(flb+1);
		
		fp = tstr.search(new RegExp("log\\_"));
	}
	return tstr;
}

function DoAbs(str)
{
	var tstr = str;
	//     
	tstr =  tstr.replace(/\\left\|/g, "[");
	tstr =  tstr.replace(/\\right\|/g, "]");
	
	var lb = tstr.indexOf("\[");
	while (lb != -1) {
		var rb = getRightBr(tstr, lb, '[', ']');
		tstr = tstr.substring(0,lb) + 'abs(' + tstr.substring(lb+1, rb) + ')' + tstr.substring(rb+1);

		lb = tstr.indexOf("\[");
	}
	if (tstr.indexOf("\[") != -1 || tstr.indexOf("\]") != -1) throw "!     ";
	return tstr;
}

// ' ^(a)sqrt(b)' -> sqrtn(b,a)
function DoSqrtn(str)
{
	var tstr = str;
	var fp = tstr.indexOf("\\:^");
	while (fp != -1) {
		var pp = fp+2;
		var pfp = pp+1;	// sqrt power first position
		var plp = pfp;	// sqrt power last position
		if (tstr[pfp] == '(') {
			plp = getRightBr(tstr, pfp);
		} else {
			plp = pfp;
		}
		if (tstr.substr(plp+1, 5) != '\\sqrt') {
			fp = tstr.indexOf("\\:^", fp+1);
			continue;
		}
		var ffb = plp+6;	// func first bracket
		if (tstr[ffb] != '(') throw "!     sqrt";
		var flb = getRightBr(tstr, ffb);	// func last bracket
		tstr = tstr.substring(0,fp) + 'sqrtn(' + tstr.substring(ffb, flb+1) + ',' + tstr.substring(pfp, plp+1) + ')' + tstr.substring(flb+1);

		fp = tstr.indexOf("\\:^", fp+1);
	}
	return tstr;
}

//  
function IsSymb(s)
{
	var cc = s.charCodeAt(0);
	if (cc >= "a".charCodeAt(0) && cc <= "z".charCodeAt(0) || cc >= "A".charCodeAt(0) && cc <= "Z".charCodeAt(0)) return true;
	return false;
}
function IsNumerDot(s)
{
	var cc = s.charCodeAt(0);
	if (cc >= "0".charCodeAt(0) && cc <= "9".charCodeAt(0) || cc == ".".charCodeAt(0)) return true;
	return false;
}

function DoFactorial(str)
{
	var tstr = str;
	var fp = tstr.indexOf("!");
	while (fp != -1) {
		if (fp==0) throw "!     ";
		if (tstr[fp-1] == ")") {
			var rb = fp-1;
			var lb = getLeftBr(tstr, rb);
			tstr = tstr.substring(0, lb) + "factorial" + tstr.substring(lb, rb+1) + tstr.substring(rb+2);
		} else {
			var pos = fp-1;
			if (IsSymb(tstr[pos])) {
				var p = pos;
				var l = pos;
			} else if (IsNumerDot(tstr[pos])) {
				var p = pos;
				while (p>=0 && IsNumerDot(tstr[p])) p--;
				var l = p+1;
			} else throw "!     ";
			tstr = tstr.substring(0, l) + "factorial(" + tstr.substring(l, fp) + ")" + tstr.substring(fp+1);
		}
		fp = tstr.indexOf("!");
	}
	return tstr;
}

var greek_letters = ['alpha', 'beta', 'gamma', 'delta', 'epsilon', 'zeta', 'theta', 'eta', 'iota', 'kappa', 'lambda', 'mu', 'nu', 'xi', 'omicron', 'pi', 'rho', 'sigma', 'tau', 'upsilon', 'phi', 'chi', 'psi', 'omega', 'Alpha', 'Beta', 'Gamma', 'Delta', 'Epsilon', 'Zeta', 'Theta', 'Eta', 'Iota', 'Kappa', 'Lambda', 'Mu', 'Nu', 'Xi', 'Omicron', 'Pi', 'Rho', 'Sigma', 'Tau', 'Upsilon', 'Phi', 'Chi', 'Psi', 'Omega'];

//      
function DoGreekLet(str)
{
	var tstr = str;
	for (i=0; i<greek_letters.length; i++)
	{
		var let = greek_letters[i];
		tstr = tstr.replace(new RegExp("\\\\"+let, 'g'), '('+let+')');
	}
	
	return tstr;
}

//    
function DoFunctions(str)
{
	var tstr = str;
	for (i=0; i<funcarr.length; i++)
	{
		var func = funcarr[i];
		var fp = tstr.indexOf(func);
		while (fp != -1) {
			if (((func == 'sin' || func == 'cos' || func == 'tg' || func == 'ctg') && fp>=3 && tstr.substring(fp-3, fp)=='arc') ||
				(func == 'sqrt' && tstr.substr(fp+4, 1)=='n') ||
				(func == 'tg' && fp>=1 && tstr.substring(fp-1, fp)=='c') ||
				(func == 'th' && fp>=1 && tstr.substring(fp-1, fp)=='c') ||
				(func == 'ctg' && fp>=2 && tstr.substring(fp-2, fp)=='ar')) {
				fp = tstr.indexOf(func, fp+1);
				continue;
			}

			var lb = fp + func.length;
			if (tstr[lb] != '(') {
				fp = tstr.indexOf(func, fp+1);
				continue;
			}
			var rb = getRightBr(tstr, lb);
			tstr = tstr.substring(0, fp) + "(" + tstr.substring(fp, rb+1) + ")" + tstr.substring(rb+1);
			
			fp = tstr.indexOf(func, fp+2);	//   
		} 
	}

    return tstr;
}


//  -   ,          
// ab -> a*b
function DoVars(str)
{
	var tstr = str;
	var i = 0;
	while (i<tstr.length) {
		if (IsSymb(tstr[i])) {
			//  ,    
			var p = i;
			var l = p;
			while (p<tstr.length && IsSymb(tstr[p])) p++;
			var r = p-1;
			if (r-l == 0) {  //  
				i++;
				continue;
			}
			var s = tstr.substring(l,r+1);
			//         
			var isf = false;
			for (j = 0; j<funcarr.length; j++)
				if (funcarr[j] == s) {
					isf = true;
					break;
				}
			if (!isf) {
				for (j = 0; j<greek_letters.length; j++)
					if (greek_letters[j] == s) {
						isf = true;
						break;
					}
			}
			if (!isf) {
				var vs = "";
				for (j=l; j<=r; j++) {
					if (j>l) vs += "*";
					vs += tstr[j];
				}
				i=r+(r-l)+1;	// (r-l) -     
				tstr = tstr.substring(0, l) + vs + tstr.substring(r+1);
			} else i = r+1;
		} else i++;
	}
	return tstr;
}

//2a -> 2*a
//a2 -> a*2
function DoVarsAndNumbers(str)
{
	var tstr = str;
	var i = 0;
	while (i<tstr.length) {
		if (IsNumerDot(tstr[i])) {
			var p = i;
			var l = p;
			while (p<tstr.length && IsNumerDot(tstr[p])) p++;
			var r = p-1;

			var s = tstr.substring(l,r+1);

			var as = "";
			var bs = "";
			var offsetL = 0;
			var offsetR = 0;
			
			if (l !== 0 && (IsSymb(tstr[l - 1]) || tstr[l - 1] == ')')) {
				bs = "*";
				offsetL++;
			}
			
			if (r !== tstr.length - 1 && (IsSymb(tstr[r + 1]) || tstr[r + 1] == '(')) {
				as = "*";
				offsetR++;
			}
			
			s = bs + s + as;
			
			i=l+s.length;
			
			tstr = tstr.substring(0, l) + s + tstr.substring(l+s.length-offsetR-offsetL);
		} else {
			i++;
		}
	}
	return tstr;
}

function getNativeMath(elem)
{
	try
	{
		var lat = getLatex(elem);
		var s = lat;
		s = DoBrackets(s);
		s = DoAbs(s);	//   DoBrackets
		s = DoSqrtn(s);	//   RemSpaces
		s = RemSpaces(s);
		s = DoFracs(s);
		s = DoDots(s);
		s = DoGreekLet(s);
		s = RemLeftSlashes(s);
		s = DoFunPows(s);
		s = DoLog(s);
		s = DoFactorial(s);
		s = DoFunctions(s);
		s = DoVars(s); //   DoFunctions  DoGreekLet       
		s = DoVarsAndNumbers(s);
		return s;
	}
	catch(e)
	{
		alert(e);
		throw e;
		return "";
	}
}

//   

$(function(){
	$.fn.ins_print = function(symb)
	{
	    var mathObj = this.data('[[mathquill internal data]]');
	    mathObj.block.cursor.show().write(symb);
	    return mathObj;
	};
	$.fn.move_left = function()
	{
	    var mathObj = this.data('[[mathquill internal data]]');
	    mathObj.block.cursor.moveLeft();
	    return mathObj;
	};
	$.fn.move_right = function()
	{
	    var mathObj = this.data('[[mathquill internal data]]');
	    mathObj.block.cursor.moveRight();
	    return mathObj;
	};
});

function InsertElem(panexpr, elem)
{
	try
	{
	for (i=0; i<elem.length; i++) {
		if (elem[i] == '~')	//  
			$('#'+panexpr).move_right();
		else if (elem[i] == '?')	//  
			$('#'+panexpr).move_left();
		else
			$('#'+panexpr).ins_print(elem.charAt(i));
	}
	$('#'+panexpr).focus();
	}
	catch(err) {alert(err)};
	return false;
}

function InsertSqrt(panexpr)
{
	$('#'+panexpr).ins_sqrt();
	$('#'+panexpr).focus();
	return false;
}

function InsertSqrtn(panexpr)
{
	InsertElem(panexpr, ' ^~');
	InsertSqrt(panexpr);
	InsertElem(panexpr, '??');
	return false;
}

function InsertLetter(panexpr, letter)
{
	try{
	$('#'+panexpr).ins_letter(letter);
	$('#'+panexpr).focus();
	}
	catch(err) {alert(err)};
	return false;
}
